"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryFiledInIncludePipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
class QueryFiledInIncludePipe {
    constructor(repository) {
        this.repository = repository;
    }
    transform(value) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const errors = [];
            const includeMap = (value['include'] || []).reduce((acum, item) => ((acum[item] = true), acum), {});
            const _a = value['fields'] || {}, { target: targetResourceFields } = _a, relationFields = tslib_1.__rest(_a, ["target"]);
            const relationFieldsArray = Object.keys(relationFields);
            if (relationFields && relationFieldsArray.length > 0) {
                errors.push(...relationFieldsArray
                    .filter((i) => !(includeMap[i] === true))
                    .map((i) => ({
                    detail: `Add '${i}' to query param 'include'`,
                    source: {
                        parameter: '/fields',
                    },
                })));
            }
            const _b = value['sort'] || {}, { target: targetResourceSort } = _b, relationSort = tslib_1.__rest(_b, ["target"]);
            const relationSortArray = Object.keys(relationSort);
            if (relationSort && Object.keys(relationSortArray).length > 0) {
                errors.push(...relationSortArray
                    .filter((i) => !(includeMap[i] === true))
                    .map((i) => ({
                    detail: `Add '${i}' to query param 'include'`,
                    source: {
                        parameter: '/sort',
                    },
                })));
            }
            if (errors.length > 0) {
                throw new common_1.BadRequestException(errors);
            }
            return value;
        });
    }
}
exports.QueryFiledInIncludePipe = QueryFiledInIncludePipe;
//# sourceMappingURL=query-filed-in-include.pipe.js.map